/* handle.c generated by valac 0.15.1, the Vala compiler
 * generated from handle.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011 Peng Huang <shawn.p.huang@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_HANDLE (handle_get_type ())
#define HANDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HANDLE, Handle))
#define HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HANDLE, HandleClass))
#define IS_HANDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HANDLE))
#define IS_HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HANDLE))
#define HANDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HANDLE, HandleClass))

typedef struct _Handle Handle;
typedef struct _HandleClass HandleClass;
typedef struct _HandlePrivate HandlePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Handle {
	GtkEventBox parent_instance;
	HandlePrivate * priv;
};

struct _HandleClass {
	GtkEventBoxClass parent_class;
};

struct _HandlePrivate {
	gboolean m_move_begined;
	cairo_rectangle_int_t m_workarea;
	GdkPoint m_press_pos;
};


static gpointer handle_parent_class = NULL;

GType handle_get_type (void) G_GNUC_CONST;
#define HANDLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_HANDLE, HandlePrivate))
enum  {
	HANDLE_DUMMY_PROPERTY
};
Handle* handle_new (void);
Handle* handle_construct (GType object_type);
static void handle_real_realize (GtkWidget* base);
static gboolean handle_real_button_press_event (GtkWidget* base, GdkEventButton* event);
static gboolean _gdk_atom_equal (const GdkAtom* s1, const GdkAtom* s2);
static gboolean handle_real_button_release_event (GtkWidget* base, GdkEventButton* event);
static gboolean handle_real_motion_notify_event (GtkWidget* base, GdkEventMotion* event);
static gboolean handle_real_draw (GtkWidget* base, cairo_t* cr);
static void handle_finalize (GObject* obj);


Handle* handle_construct (GType object_type) {
	Handle * self = NULL;
	GdkEventMask mask;
	self = (Handle*) g_object_new (object_type, NULL);
	gtk_widget_set_size_request ((GtkWidget*) self, 6, -1);
	mask = ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_BUTTON1_MOTION_MASK;
	gtk_widget_set_events ((GtkWidget*) self, (gint) mask);
	self->priv->m_move_begined = FALSE;
	return self;
}


Handle* handle_new (void) {
	return handle_construct (TYPE_HANDLE);
}


static void handle_real_realize (GtkWidget* base) {
	Handle * self;
	self = (Handle*) base;
	GTK_WIDGET_CLASS (handle_parent_class)->realize ((GtkWidget*) GTK_EVENT_BOX (self));
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean _gdk_atom_equal (const GdkAtom* s1, const GdkAtom* s2) {
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}


static gboolean handle_real_button_press_event (GtkWidget* base, GdkEventButton* event) {
	Handle * self;
	gboolean result = FALSE;
	GdkEventButton _tmp0_;
	guint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_rectangle_int_t _tmp4_ = {0};
	gint x = 0;
	gint y = 0;
	GtkWidget* _tmp114_ = NULL;
	GtkWindow* _tmp115_;
	GtkWindow* toplevel;
	GtkWindow* _tmp116_;
	gint _tmp117_ = 0;
	gint _tmp118_ = 0;
	GdkEventButton _tmp119_;
	gdouble _tmp120_;
	gint _tmp121_;
	GdkEventButton _tmp122_;
	gdouble _tmp123_;
	gint _tmp124_;
	GdkPoint _tmp125_ = {0};
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = *event;
	_tmp1_ = _tmp0_.button;
	if (_tmp1_ != ((guint) 1)) {
		result = FALSE;
		return result;
	}
	_tmp2_ = G_MAXINT;
	_tmp3_ = G_MAXINT;
	_tmp4_.x = 0;
	_tmp4_.y = 0;
	_tmp4_.width = _tmp2_;
	_tmp4_.height = _tmp3_;
	self->priv->m_workarea = _tmp4_;
	{
		gboolean _tmp5_;
		_tmp5_ = TRUE;
		while (TRUE) {
			gboolean _tmp6_;
			GdkWindow* _tmp7_ = NULL;
			GdkWindow* _tmp8_;
			GdkWindow* root;
			GdkAtom _tmp9_ = {0};
			GdkAtom property;
			GdkAtom _tmp10_ = {0};
			GdkAtom type;
			GdkAtom actual_type = {0};
			gint format = 0;
			guchar* data = NULL;
			gint data_length1 = 0;
			gint _data_size_ = 0;
			gboolean _result_ = FALSE;
			GdkWindow* _tmp11_;
			GdkAtom _tmp12_;
			GdkAtom _tmp13_;
			glong _tmp14_;
			GdkAtom _tmp15_ = {0};
			gint _tmp16_ = 0;
			guint8* _tmp17_ = NULL;
			gint _tmp18_ = 0;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_ = FALSE;
			gboolean _tmp23_;
			gboolean _tmp26_;
			gboolean _tmp28_;
			gboolean _tmp30_;
			guchar* _tmp31_;
			gint _tmp31__length1;
			guchar _tmp32_;
			guchar* _tmp33_;
			gint _tmp33__length1;
			guchar _tmp34_;
			guchar* _tmp35_;
			gint _tmp35__length1;
			guchar _tmp36_;
			guchar* _tmp37_;
			gint _tmp37__length1;
			guchar _tmp38_;
			gint index;
			GdkAtom _tmp39_ = {0};
			GdkAtom _tmp40_ = {0};
			GdkWindow* _tmp41_;
			GdkAtom _tmp42_;
			GdkAtom _tmp43_;
			glong _tmp44_;
			GdkAtom _tmp45_ = {0};
			gint _tmp46_ = 0;
			guint8* _tmp47_ = NULL;
			gint _tmp48_ = 0;
			gboolean _tmp49_ = FALSE;
			gboolean _tmp50_ = FALSE;
			gboolean _tmp51_ = FALSE;
			gboolean _tmp52_ = FALSE;
			gboolean _tmp53_;
			gboolean _tmp56_;
			gboolean _tmp58_;
			gboolean _tmp61_;
			gint _tmp62_;
			gint i;
			guchar* _tmp63_;
			gint _tmp63__length1;
			gint _tmp64_;
			guchar _tmp65_;
			guchar* _tmp66_;
			gint _tmp66__length1;
			gint _tmp67_;
			guchar _tmp68_;
			guchar* _tmp69_;
			gint _tmp69__length1;
			gint _tmp70_;
			guchar _tmp71_;
			guchar* _tmp72_;
			gint _tmp72__length1;
			gint _tmp73_;
			guchar _tmp74_;
			gint _tmp75_;
			guchar* _tmp76_;
			gint _tmp76__length1;
			gint _tmp77_;
			guchar _tmp78_;
			guchar* _tmp79_;
			gint _tmp79__length1;
			gint _tmp80_;
			guchar _tmp81_;
			guchar* _tmp82_;
			gint _tmp82__length1;
			gint _tmp83_;
			guchar _tmp84_;
			guchar* _tmp85_;
			gint _tmp85__length1;
			gint _tmp86_;
			guchar _tmp87_;
			gint _tmp88_;
			guchar* _tmp89_;
			gint _tmp89__length1;
			gint _tmp90_;
			guchar _tmp91_;
			guchar* _tmp92_;
			gint _tmp92__length1;
			gint _tmp93_;
			guchar _tmp94_;
			guchar* _tmp95_;
			gint _tmp95__length1;
			gint _tmp96_;
			guchar _tmp97_;
			guchar* _tmp98_;
			gint _tmp98__length1;
			gint _tmp99_;
			guchar _tmp100_;
			gint _tmp101_;
			guchar* _tmp102_;
			gint _tmp102__length1;
			gint _tmp103_;
			guchar _tmp104_;
			guchar* _tmp105_;
			gint _tmp105__length1;
			gint _tmp106_;
			guchar _tmp107_;
			guchar* _tmp108_;
			gint _tmp108__length1;
			gint _tmp109_;
			guchar _tmp110_;
			guchar* _tmp111_;
			gint _tmp111__length1;
			gint _tmp112_;
			guchar _tmp113_;
			_tmp6_ = _tmp5_;
			if (!_tmp6_) {
				if (!FALSE) {
					break;
				}
			}
			_tmp5_ = FALSE;
			_tmp7_ = gdk_get_default_root_window ();
			_tmp8_ = _g_object_ref0 (_tmp7_);
			root = _tmp8_;
			_tmp9_ = gdk_atom_intern ("_NET_CURRENT_DESKTOP", FALSE);
			property = _tmp9_;
			_tmp10_ = gdk_atom_intern ("CARDINAL", FALSE);
			type = _tmp10_;
			_tmp11_ = root;
			_tmp12_ = property;
			_tmp13_ = type;
			_tmp14_ = G_MAXLONG;
			_tmp19_ = gdk_property_get (_tmp11_, _tmp12_, _tmp13_, (gulong) 0, (gulong) _tmp14_, 0, &_tmp15_, &_tmp16_, &_tmp18_, &_tmp17_);
			actual_type = _tmp15_;
			format = _tmp16_;
			data = (g_free (data), NULL);
			data = _tmp17_;
			data_length1 = _tmp18_;
			_data_size_ = data_length1;
			_result_ = _tmp19_;
			_tmp23_ = _result_;
			if (!_tmp23_) {
				_tmp22_ = TRUE;
			} else {
				GdkAtom _tmp24_;
				GdkAtom _tmp25_;
				_tmp24_ = actual_type;
				_tmp25_ = type;
				_tmp22_ = _gdk_atom_equal (&_tmp24_, &_tmp25_) != TRUE;
			}
			_tmp26_ = _tmp22_;
			if (_tmp26_) {
				_tmp21_ = TRUE;
			} else {
				gint _tmp27_;
				_tmp27_ = format;
				_tmp21_ = _tmp27_ != 32;
			}
			_tmp28_ = _tmp21_;
			if (_tmp28_) {
				_tmp20_ = TRUE;
			} else {
				guchar* _tmp29_;
				gint _tmp29__length1;
				_tmp29_ = data;
				_tmp29__length1 = data_length1;
				_tmp20_ = _tmp29__length1 != 4;
			}
			_tmp30_ = _tmp20_;
			if (_tmp30_) {
				data = (g_free (data), NULL);
				_g_object_unref0 (root);
				break;
			}
			_tmp31_ = data;
			_tmp31__length1 = data_length1;
			_tmp32_ = _tmp31_[0];
			_tmp33_ = data;
			_tmp33__length1 = data_length1;
			_tmp34_ = _tmp33_[1];
			_tmp35_ = data;
			_tmp35__length1 = data_length1;
			_tmp36_ = _tmp35_[2];
			_tmp37_ = data;
			_tmp37__length1 = data_length1;
			_tmp38_ = _tmp37_[3];
			index = (gint) (((_tmp32_ | (_tmp34_ << 8)) | (_tmp36_ << 16)) | (_tmp38_ << 24));
			_tmp39_ = gdk_atom_intern ("_NET_WORKAREA", FALSE);
			property = _tmp39_;
			_tmp40_ = gdk_atom_intern ("CARDINAL", FALSE);
			type = _tmp40_;
			_tmp41_ = root;
			_tmp42_ = property;
			_tmp43_ = type;
			_tmp44_ = G_MAXLONG;
			_tmp49_ = gdk_property_get (_tmp41_, _tmp42_, _tmp43_, (gulong) 0, (gulong) _tmp44_, 0, &_tmp45_, &_tmp46_, &_tmp48_, &_tmp47_);
			actual_type = _tmp45_;
			format = _tmp46_;
			data = (g_free (data), NULL);
			data = _tmp47_;
			data_length1 = _tmp48_;
			_data_size_ = data_length1;
			_result_ = _tmp49_;
			_tmp53_ = _result_;
			if (!_tmp53_) {
				_tmp52_ = TRUE;
			} else {
				GdkAtom _tmp54_;
				GdkAtom _tmp55_;
				_tmp54_ = actual_type;
				_tmp55_ = type;
				_tmp52_ = _gdk_atom_equal (&_tmp54_, &_tmp55_) != TRUE;
			}
			_tmp56_ = _tmp52_;
			if (_tmp56_) {
				_tmp51_ = TRUE;
			} else {
				gint _tmp57_;
				_tmp57_ = format;
				_tmp51_ = _tmp57_ != 32;
			}
			_tmp58_ = _tmp51_;
			if (_tmp58_) {
				_tmp50_ = TRUE;
			} else {
				guchar* _tmp59_;
				gint _tmp59__length1;
				gint _tmp60_;
				_tmp59_ = data;
				_tmp59__length1 = data_length1;
				_tmp60_ = index;
				_tmp50_ = _tmp59__length1 < ((_tmp60_ + 1) * 16);
			}
			_tmp61_ = _tmp50_;
			if (_tmp61_) {
				data = (g_free (data), NULL);
				_g_object_unref0 (root);
				break;
			}
			_tmp62_ = index;
			i = (_tmp62_ * 4) * 4;
			_tmp63_ = data;
			_tmp63__length1 = data_length1;
			_tmp64_ = i;
			_tmp65_ = _tmp63_[_tmp64_];
			_tmp66_ = data;
			_tmp66__length1 = data_length1;
			_tmp67_ = i;
			_tmp68_ = _tmp66_[_tmp67_ + 1];
			_tmp69_ = data;
			_tmp69__length1 = data_length1;
			_tmp70_ = i;
			_tmp71_ = _tmp69_[_tmp70_ + 2];
			_tmp72_ = data;
			_tmp72__length1 = data_length1;
			_tmp73_ = i;
			_tmp74_ = _tmp72_[_tmp73_ + 3];
			self->priv->m_workarea.x = (gint) (((_tmp65_ | (_tmp68_ << 8)) | (_tmp71_ << 16)) | (_tmp74_ << 24));
			_tmp75_ = i;
			i = _tmp75_ + 4;
			_tmp76_ = data;
			_tmp76__length1 = data_length1;
			_tmp77_ = i;
			_tmp78_ = _tmp76_[_tmp77_];
			_tmp79_ = data;
			_tmp79__length1 = data_length1;
			_tmp80_ = i;
			_tmp81_ = _tmp79_[_tmp80_ + 1];
			_tmp82_ = data;
			_tmp82__length1 = data_length1;
			_tmp83_ = i;
			_tmp84_ = _tmp82_[_tmp83_ + 2];
			_tmp85_ = data;
			_tmp85__length1 = data_length1;
			_tmp86_ = i;
			_tmp87_ = _tmp85_[_tmp86_ + 3];
			self->priv->m_workarea.y = (gint) (((_tmp78_ | (_tmp81_ << 8)) | (_tmp84_ << 16)) | (_tmp87_ << 24));
			_tmp88_ = i;
			i = _tmp88_ + 4;
			_tmp89_ = data;
			_tmp89__length1 = data_length1;
			_tmp90_ = i;
			_tmp91_ = _tmp89_[_tmp90_];
			_tmp92_ = data;
			_tmp92__length1 = data_length1;
			_tmp93_ = i;
			_tmp94_ = _tmp92_[_tmp93_ + 1];
			_tmp95_ = data;
			_tmp95__length1 = data_length1;
			_tmp96_ = i;
			_tmp97_ = _tmp95_[_tmp96_ + 2];
			_tmp98_ = data;
			_tmp98__length1 = data_length1;
			_tmp99_ = i;
			_tmp100_ = _tmp98_[_tmp99_ + 3];
			self->priv->m_workarea.width = (gint) (((_tmp91_ | (_tmp94_ << 8)) | (_tmp97_ << 16)) | (_tmp100_ << 24));
			_tmp101_ = i;
			i = _tmp101_ + 4;
			_tmp102_ = data;
			_tmp102__length1 = data_length1;
			_tmp103_ = i;
			_tmp104_ = _tmp102_[_tmp103_];
			_tmp105_ = data;
			_tmp105__length1 = data_length1;
			_tmp106_ = i;
			_tmp107_ = _tmp105_[_tmp106_ + 1];
			_tmp108_ = data;
			_tmp108__length1 = data_length1;
			_tmp109_ = i;
			_tmp110_ = _tmp108_[_tmp109_ + 2];
			_tmp111_ = data;
			_tmp111__length1 = data_length1;
			_tmp112_ = i;
			_tmp113_ = _tmp111_[_tmp112_ + 3];
			self->priv->m_workarea.height = (gint) (((_tmp104_ | (_tmp107_ << 8)) | (_tmp110_ << 16)) | (_tmp113_ << 24));
			data = (g_free (data), NULL);
			_g_object_unref0 (root);
		}
	}
	self->priv->m_move_begined = TRUE;
	_tmp114_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp115_ = _g_object_ref0 (GTK_WINDOW (_tmp114_));
	toplevel = _tmp115_;
	_tmp116_ = toplevel;
	gtk_window_get_position (_tmp116_, &_tmp117_, &_tmp118_);
	x = _tmp117_;
	y = _tmp118_;
	_tmp119_ = *event;
	_tmp120_ = _tmp119_.x_root;
	_tmp121_ = x;
	_tmp122_ = *event;
	_tmp123_ = _tmp122_.y_root;
	_tmp124_ = y;
	_tmp125_.x = ((gint) _tmp120_) - _tmp121_;
	_tmp125_.y = ((gint) _tmp123_) - _tmp124_;
	self->priv->m_press_pos = _tmp125_;
	g_signal_emit_by_name (self, "move-begin");
	result = TRUE;
	_g_object_unref0 (toplevel);
	return result;
}


static gboolean handle_real_button_release_event (GtkWidget* base, GdkEventButton* event) {
	Handle * self;
	gboolean result = FALSE;
	GdkEventButton _tmp0_;
	guint _tmp1_;
	GdkPoint _tmp2_ = {0};
	GdkWindow* _tmp3_ = NULL;
	GdkCursor* _tmp4_;
	GdkCursor* _tmp5_;
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = *event;
	_tmp1_ = _tmp0_.button;
	if (_tmp1_ != ((guint) 1)) {
		result = FALSE;
		return result;
	}
	self->priv->m_move_begined = FALSE;
	_tmp2_.x = 0;
	_tmp2_.y = 0;
	self->priv->m_press_pos = _tmp2_;
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp4_ = gdk_cursor_new (GDK_LEFT_PTR);
	_tmp5_ = _tmp4_;
	gdk_window_set_cursor (_tmp3_, _tmp5_);
	_g_object_unref0 (_tmp5_);
	g_signal_emit_by_name (self, "move-end");
	result = TRUE;
	return result;
}


static gboolean handle_real_motion_notify_event (GtkWidget* base, GdkEventMotion* event) {
	Handle * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	GtkWidget* _tmp1_ = NULL;
	GtkWindow* _tmp2_;
	GtkWindow* toplevel;
	GdkEventMotion _tmp3_;
	gdouble _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	gint x;
	GdkEventMotion _tmp7_;
	gdouble _tmp8_;
	GdkPoint _tmp9_;
	gint _tmp10_;
	gint y;
	gboolean _tmp11_ = FALSE;
	gint _tmp12_;
	cairo_rectangle_int_t _tmp13_;
	gint _tmp14_;
	gboolean _tmp18_;
	gboolean _tmp21_ = FALSE;
	gint _tmp22_;
	cairo_rectangle_int_t _tmp23_;
	gint _tmp24_;
	gboolean _tmp28_;
	gint w = 0;
	gint h = 0;
	GtkWindow* _tmp31_;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gboolean _tmp34_ = FALSE;
	gint _tmp35_;
	gint _tmp36_;
	cairo_rectangle_int_t _tmp37_;
	gint _tmp38_;
	cairo_rectangle_int_t _tmp39_;
	gint _tmp40_;
	gboolean _tmp47_;
	gboolean _tmp53_ = FALSE;
	gint _tmp54_;
	gint _tmp55_;
	cairo_rectangle_int_t _tmp56_;
	gint _tmp57_;
	cairo_rectangle_int_t _tmp58_;
	gint _tmp59_;
	gboolean _tmp66_;
	GtkWindow* _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->m_move_begined;
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp2_ = _g_object_ref0 (GTK_WINDOW (_tmp1_));
	toplevel = _tmp2_;
	_tmp3_ = *event;
	_tmp4_ = _tmp3_.x_root;
	_tmp5_ = self->priv->m_press_pos;
	_tmp6_ = _tmp5_.x;
	x = (gint) (_tmp4_ - _tmp6_);
	_tmp7_ = *event;
	_tmp8_ = _tmp7_.y_root;
	_tmp9_ = self->priv->m_press_pos;
	_tmp10_ = _tmp9_.y;
	y = (gint) (_tmp8_ - _tmp10_);
	_tmp12_ = x;
	_tmp13_ = self->priv->m_workarea;
	_tmp14_ = _tmp13_.x;
	if (_tmp12_ < _tmp14_) {
		gint _tmp15_;
		cairo_rectangle_int_t _tmp16_;
		gint _tmp17_;
		_tmp15_ = x;
		_tmp16_ = self->priv->m_workarea;
		_tmp17_ = _tmp16_.x;
		_tmp11_ = _tmp15_ > (_tmp17_ - 16);
	} else {
		_tmp11_ = FALSE;
	}
	_tmp18_ = _tmp11_;
	if (_tmp18_) {
		cairo_rectangle_int_t _tmp19_;
		gint _tmp20_;
		_tmp19_ = self->priv->m_workarea;
		_tmp20_ = _tmp19_.x;
		x = _tmp20_;
	}
	_tmp22_ = y;
	_tmp23_ = self->priv->m_workarea;
	_tmp24_ = _tmp23_.y;
	if (_tmp22_ < _tmp24_) {
		gint _tmp25_;
		cairo_rectangle_int_t _tmp26_;
		gint _tmp27_;
		_tmp25_ = y;
		_tmp26_ = self->priv->m_workarea;
		_tmp27_ = _tmp26_.y;
		_tmp21_ = _tmp25_ > (_tmp27_ - 16);
	} else {
		_tmp21_ = FALSE;
	}
	_tmp28_ = _tmp21_;
	if (_tmp28_) {
		cairo_rectangle_int_t _tmp29_;
		gint _tmp30_;
		_tmp29_ = self->priv->m_workarea;
		_tmp30_ = _tmp29_.y;
		y = _tmp30_;
	}
	_tmp31_ = toplevel;
	gtk_window_get_size (_tmp31_, &_tmp32_, &_tmp33_);
	w = _tmp32_;
	h = _tmp33_;
	_tmp35_ = x;
	_tmp36_ = w;
	_tmp37_ = self->priv->m_workarea;
	_tmp38_ = _tmp37_.x;
	_tmp39_ = self->priv->m_workarea;
	_tmp40_ = _tmp39_.width;
	if ((_tmp35_ + _tmp36_) > (_tmp38_ + _tmp40_)) {
		gint _tmp41_;
		gint _tmp42_;
		cairo_rectangle_int_t _tmp43_;
		gint _tmp44_;
		cairo_rectangle_int_t _tmp45_;
		gint _tmp46_;
		_tmp41_ = x;
		_tmp42_ = w;
		_tmp43_ = self->priv->m_workarea;
		_tmp44_ = _tmp43_.x;
		_tmp45_ = self->priv->m_workarea;
		_tmp46_ = _tmp45_.width;
		_tmp34_ = (_tmp41_ + _tmp42_) < ((_tmp44_ + _tmp46_) + 16);
	} else {
		_tmp34_ = FALSE;
	}
	_tmp47_ = _tmp34_;
	if (_tmp47_) {
		cairo_rectangle_int_t _tmp48_;
		gint _tmp49_;
		cairo_rectangle_int_t _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
		_tmp48_ = self->priv->m_workarea;
		_tmp49_ = _tmp48_.x;
		_tmp50_ = self->priv->m_workarea;
		_tmp51_ = _tmp50_.width;
		_tmp52_ = w;
		x = (_tmp49_ + _tmp51_) - _tmp52_;
	}
	_tmp54_ = y;
	_tmp55_ = h;
	_tmp56_ = self->priv->m_workarea;
	_tmp57_ = _tmp56_.y;
	_tmp58_ = self->priv->m_workarea;
	_tmp59_ = _tmp58_.height;
	if ((_tmp54_ + _tmp55_) > (_tmp57_ + _tmp59_)) {
		gint _tmp60_;
		gint _tmp61_;
		cairo_rectangle_int_t _tmp62_;
		gint _tmp63_;
		cairo_rectangle_int_t _tmp64_;
		gint _tmp65_;
		_tmp60_ = y;
		_tmp61_ = h;
		_tmp62_ = self->priv->m_workarea;
		_tmp63_ = _tmp62_.y;
		_tmp64_ = self->priv->m_workarea;
		_tmp65_ = _tmp64_.height;
		_tmp53_ = (_tmp60_ + _tmp61_) < ((_tmp63_ + _tmp65_) + 16);
	} else {
		_tmp53_ = FALSE;
	}
	_tmp66_ = _tmp53_;
	if (_tmp66_) {
		cairo_rectangle_int_t _tmp67_;
		gint _tmp68_;
		cairo_rectangle_int_t _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
		_tmp67_ = self->priv->m_workarea;
		_tmp68_ = _tmp67_.y;
		_tmp69_ = self->priv->m_workarea;
		_tmp70_ = _tmp69_.height;
		_tmp71_ = w;
		y = (_tmp68_ + _tmp70_) - _tmp71_;
	}
	_tmp72_ = toplevel;
	_tmp73_ = x;
	_tmp74_ = y;
	gtk_window_move (_tmp72_, _tmp73_, _tmp74_);
	result = TRUE;
	_g_object_unref0 (toplevel);
	return result;
}


static gboolean handle_real_draw (GtkWidget* base, cairo_t* cr) {
	Handle * self;
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	GdkWindow* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	self = (Handle*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = cr;
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp2_ = gtk_cairo_should_draw_window (_tmp0_, _tmp1_);
	if (_tmp2_) {
		GtkStyleContext* _tmp3_ = NULL;
		GtkStyleContext* _tmp4_;
		GtkStyleContext* context;
		GtkAllocation allocation = {0};
		GtkAllocation _tmp5_ = {0};
		GtkStyleContext* _tmp6_;
		cairo_t* _tmp7_;
		GtkAllocation _tmp8_;
		gint _tmp9_;
		GtkAllocation _tmp10_;
		gint _tmp11_;
		GtkAllocation _tmp12_;
		gint _tmp13_;
		GtkAllocation _tmp14_;
		gint _tmp15_;
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		context = _tmp4_;
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp5_);
		allocation = _tmp5_;
		_tmp6_ = context;
		_tmp7_ = cr;
		_tmp8_ = allocation;
		_tmp9_ = _tmp8_.x;
		_tmp10_ = allocation;
		_tmp11_ = _tmp10_.y;
		_tmp12_ = allocation;
		_tmp13_ = _tmp12_.height;
		_tmp14_ = allocation;
		_tmp15_ = _tmp14_.width;
		gtk_render_handle (_tmp6_, _tmp7_, (gdouble) _tmp9_, (gdouble) (_tmp11_ + ((_tmp13_ - 40) / 2)), (gdouble) _tmp15_, 40.0);
		_g_object_unref0 (context);
	}
	result = FALSE;
	return result;
}


static void handle_class_init (HandleClass * klass) {
	handle_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (HandlePrivate));
	GTK_WIDGET_CLASS (klass)->realize = handle_real_realize;
	GTK_WIDGET_CLASS (klass)->button_press_event = handle_real_button_press_event;
	GTK_WIDGET_CLASS (klass)->button_release_event = handle_real_button_release_event;
	GTK_WIDGET_CLASS (klass)->motion_notify_event = handle_real_motion_notify_event;
	GTK_WIDGET_CLASS (klass)->draw = handle_real_draw;
	G_OBJECT_CLASS (klass)->finalize = handle_finalize;
	g_signal_new ("move_begin", TYPE_HANDLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("move_end", TYPE_HANDLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void handle_instance_init (Handle * self) {
	self->priv = HANDLE_GET_PRIVATE (self);
}


static void handle_finalize (GObject* obj) {
	Handle * self;
	self = HANDLE (obj);
	G_OBJECT_CLASS (handle_parent_class)->finalize (obj);
}


GType handle_get_type (void) {
	static volatile gsize handle_type_id__volatile = 0;
	if (g_once_init_enter (&handle_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (HandleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) handle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Handle), 0, (GInstanceInitFunc) handle_instance_init, NULL };
		GType handle_type_id;
		handle_type_id = g_type_register_static (GTK_TYPE_EVENT_BOX, "Handle", &g_define_type_info, 0);
		g_once_init_leave (&handle_type_id__volatile, handle_type_id);
	}
	return handle_type_id__volatile;
}



